/*

(C) 1997  Petr Lastovicka
 
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License.

Poet smyek: S,X
Poet obh:  D,C
Vstednost:  F,V, G,B
Barvy:        0-9
Konec:        ESC
*/
//---------------------------------------------------------------------------
#include <windows.h>
#include <math.h>
#include <stdio.h>
#define M_PI        3.14159265358979323846
/*
 USERC("krivky.rc");
*/
//---------------------------------------------------------------------------
COLORREF BARVY[10]={0x999999L,0xee0000L,0xee00L,0xdddd00L,0xffL,0xee00eeL,
  0xeeeeL,0xbbbbbbL,0xcc33aaL,0xbb55ffL};

int s=11,c=7,k=50;
COLORREF barva=RGB(240,90,150);
char title[32]="Kivky  -   ";
//---------------------------------------------------------------------------
//nejvt spolen dlitel
int NSD(int a,int b)
{
 int c;
 while(b){ c=b; b=a%b; a=c; }
 return a;
}
//---------------------------------------------------------------------------
LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wP, LPARAM lP)
{
int R,c1;
float f,p,rm,rv,rs;
RECT rc;
HDC hdc;
PAINTSTRUCT ps;

switch (msg) {

 case WM_PAINT:
  hdc=BeginPaint(hWnd,&ps);
 //zjisti rozmry okna
  GetClientRect(hWnd,&rc);
  R=rc.right;
  if(R>rc.bottom) R=rc.bottom;
  R/=2;
  c1=c;
  if(R>9){
  //vpoet polomr pro hlavn a men krunici
   while(c1>1 && NSD(c1,s)!=1) c1--;
   rv= R-R/( p=(float)s/c1 );
   rm= float(R)*k/p/100;
  //uprav polomry na rozmr okna
   rs=float(R)/(rm+rv);
   rv*=rs;
   rm*=rs;
   p--;
  //nakresli cykloidu do kruhu
   for(f=float(c*2*M_PI); f>0; f-=(float)3e-3)
    SetPixel(hdc,int(cos(f)*rv + cos(f*p)*rm) +R,
             int(sin(f)*rv - sin(f*p)*rm) +R,
             barva);
  }
  EndPaint(hWnd,&ps);

 //parametry se zobraz v nzvu okna
  sprintf(title+12,"%d / %d   %d%%",s,c1,k);
  SetWindowText(hWnd,title);
 break;

 case WM_KEYDOWN:
  if(wP>='0' && wP<='9'){
    barva=BARVY[wP-'0'];
    InvalidateRect(hWnd,NULL,TRUE);
  }
  switch(wP){
   case'S': case VK_RIGHT:
     if(s<50) s++; break;
   case'X': case VK_LEFT:
     if(s>c+1) s--; break;
   case'D': case VK_UP:
     while(c<s-1 && NSD(++c,s)!=1); break;
   case'C': case VK_DOWN:
     while(c>1 && NSD(--c,s)!=1); break;
   case'F': case VK_HOME:
     k+=10; if(k>100) k=100; break;
   case'V': case VK_END:
     k-=10; if(k<10) k=10; break;
   case'G': case VK_PRIOR:
     if(k<=99) k++; break;
   case'B': case VK_NEXT:
     if(k>1) k--; break;
   case VK_ESCAPE:
     DestroyWindow(hWnd);
   default:
     return 0;
  }
 //!
 case WM_SIZE:
  InvalidateRect(hWnd,NULL,TRUE);
  break;
 case WM_DESTROY:
  PostQuitMessage(0);
  break;
 default:
  return DefWindowProc(hWnd, msg, wP, lP);
}
return 0;
}
//---------------------------------------------------------------------------
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrev, LPSTR, int cmdShow)
{
 MSG msg;
 WNDCLASS wc;
 int Y,R;
 HWND hWin;

//vytvo tvercov okno maximalizovan
 R=GetSystemMetrics(SM_CYFULLSCREEN);
 Y=GetSystemMetrics(SM_CYCAPTION);

 wc.style=0;
 wc.lpfnWndProc=MainWndProc;
 wc.cbClsExtra= wc.cbWndExtra= 0;
 wc.hInstance=	hInstance;
 wc.hIcon=	LoadIcon(hInstance, "MAINICON");
 wc.hCursor=	LoadCursor(NULL, IDC_ARROW);
 wc.hbrBackground=	(HBRUSH)GetStockObject(BLACK_BRUSH);
 wc.lpszMenuName=	NULL;
 wc.lpszClassName=	"KrivkyWndCls";
 if(!hPrev && !RegisterClass(&wc)) return 1;

 hWin = CreateWindow(
    	"KrivkyWndCls", "",
    	WS_OVERLAPPEDWINDOW,
	    80,0, R,R+Y,
      NULL, NULL, hInstance, NULL
 );
 if(!hWin) return 2;
 ShowWindow(hWin, cmdShow);

 while(GetMessage(&msg, NULL, 0, 0)){
   DispatchMessage(&msg);
 }
 return msg.wParam;
}
